/* This file has been generated by the Perl script `afblue.pl', */
/* using data from file `afblue.dat'.                           */

/***************************************************************************/
/*                                                                         */
/*  afblue.h                                                               */
/*                                                                         */
/*    Auto-fitter data for blue strings (specification).                   */
/*                                                                         */
/*  Copyright 2013-2017 by                                                 */
/*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
/*                                                                         */
/*  This file is part of the FreeType project, and may only be used,       */
/*  modified, and distributed under the terms of the FreeType project      */
/*  license, LICENSE.TXT.  By continuing to use, modify, or distribute     */
/*  this file you indicate that you have read the license and              */
/*  understand and accept it fully.                                        */
/*                                                                         */
/***************************************************************************/


#ifndef AFBLUE_H_
#define AFBLUE_H_


FT_BEGIN_HEADER


  /* an auxiliary macro to decode a UTF-8 character -- since we only use */
  /* hard-coded, self-converted data, no error checking is performed     */
#define GET_UTF8_CHAR( ch, p )                      \
          do                                        \
          {                                         \
            ch = (unsigned char)*p++;               \
            if ( ch >= 0x80 )                       \
            {                                       \
              FT_UInt  len_;                        \
                                                    \
                                                    \
              if ( ch < 0xE0 )                      \
              {                                     \
                len_ = 1;                           \
                ch  &= 0x1F;                        \
              }                                     \
              else if ( ch < 0xF0 )                 \
              {                                     \
                len_ = 2;                           \
                ch  &= 0x0F;                        \
              }                                     \
              else                                  \
              {                                     \
                len_ = 3;                           \
                ch  &= 0x07;                        \
              }                                     \
                                                    \
              for ( ; len_ > 0; len_-- )            \
                ch = ( ch << 6 ) | ( *p++ & 0x3F ); \
            }                                       \
          } while ( 0 )


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                    B L U E   S T R I N G S                    *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* At the bottommost level, we define strings for finding blue zones. */


#define AF_BLUE_STRING_MAX_LEN  51

  /* The AF_Blue_String enumeration values are offsets into the */
  /* `af_blue_strings' array.                                   */

  typedef enum  AF_Blue_String_
  {
    AF_BLUE_STRING_ADLAM_CAPITAL_TOP = 0,
    AF_BLUE_STRING_ADLAM_CAPITAL_BOTTOM = 30,
    AF_BLUE_STRING_ADLAM_SMALL_TOP = 40,
    AF_BLUE_STRING_ADLAM_SMALL_BOTTOM = 65,
    AF_BLUE_STRING_ARABIC_TOP = 105,
    AF_BLUE_STRING_ARABIC_BOTTOM = 123,
    AF_BLUE_STRING_ARABIC_JOIN = 138,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_TOP = 141,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_BOTTOM = 165,
    AF_BLUE_STRING_ARMENIAN_SMALL_ASCENDER = 189,
    AF_BLUE_STRING_ARMENIAN_SMALL_TOP = 210,
    AF_BLUE_STRING_ARMENIAN_SMALL_BOTTOM = 234,
    AF_BLUE_STRING_ARMENIAN_SMALL_DESCENDER = 258,
    AF_BLUE_STRING_AVESTAN_TOP = 282,
    AF_BLUE_STRING_AVESTAN_BOTTOM = 302,
    AF_BLUE_STRING_BENGALI_BASE = 312,
    AF_BLUE_STRING_BENGALI_TOP = 344,
    AF_BLUE_STRING_BENGALI_HEAD = 372,
    AF_BLUE_STRING_BUHID_TOP = 404,
    AF_BLUE_STRING_BUHID_LARGE = 412,
    AF_BLUE_STRING_BUHID_SMALL = 424,
    AF_BLUE_STRING_BUHID_BOTTOM = 440,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_TOP = 468,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_BOTTOM = 500,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_TOP = 532,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_BOTTOM = 564,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_TOP = 596,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_BOTTOM = 624,
    AF_BLUE_STRING_CARIAN_TOP = 656,
    AF_BLUE_STRING_CARIAN_BOTTOM = 696,
    AF_BLUE_STRING_CHEROKEE_CAPITAL = 731,
    AF_BLUE_STRING_CHEROKEE_SMALL_ASCENDER = 763,
    AF_BLUE_STRING_CHEROKEE_SMALL = 795,
    AF_BLUE_STRING_CHEROKEE_SMALL_DESCENDER = 827,
    AF_BLUE_STRING_COPTIC_CAPITAL_TOP = 843,
    AF_BLUE_STRING_COPTIC_CAPITAL_BOTTOM = 875,
    AF_BLUE_STRING_COPTIC_SMALL_TOP = 907,
    AF_BLUE_STRING_COPTIC_SMALL_BOTTOM = 939,
    AF_BLUE_STRING_CYPRIOT_TOP = 971,
    AF_BLUE_STRING_CYPRIOT_BOTTOM = 1011,
    AF_BLUE_STRING_CYPRIOT_SMALL = 1046,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_TOP = 1061,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_BOTTOM = 1085,
    AF_BLUE_STRING_CYRILLIC_SMALL = 1109,
    AF_BLUE_STRING_CYRILLIC_SMALL_DESCENDER = 1133,
    AF_BLUE_STRING_DESERET_CAPITAL_TOP = 1142,
    AF_BLUE_STRING_DESERET_CAPITAL_BOTTOM = 1167,
    AF_BLUE_STRING_DESERET_SMALL_TOP = 1192,
    AF_BLUE_STRING_DESERET_SMALL_BOTTOM = 1217,
    AF_BLUE_STRING_DEVANAGARI_BASE = 1242,
    AF_BLUE_STRING_DEVANAGARI_TOP = 1274,
    AF_BLUE_STRING_DEVANAGARI_HEAD = 1306,
    AF_BLUE_STRING_DEVANAGARI_BOTTOM = 1338,
    AF_BLUE_STRING_ETHIOPIC_TOP = 1346,
    AF_BLUE_STRING_ETHIOPIC_BOTTOM = 1378,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_TOP = 1410,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_BOTTOM = 1442,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_ASCENDER = 1474,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_DESCENDER = 1506,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_TOP = 1538,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_BOTTOM = 1570,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_TOP = 1602,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_BOTTOM = 1634,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_ASCENDER = 1666,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_DESCENDER = 1698,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_TOP = 1730,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_BOTTOM = 1762,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_TOP = 1794,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_BOTTOM = 1826,
    AF_BLUE_STRING_GOTHIC_TOP = 1858,
    AF_BLUE_STRING_GOTHIC_BOTTOM = 1898,
    AF_BLUE_STRING_GREEK_CAPITAL_TOP = 1918,
    AF_BLUE_STRING_GREEK_CAPITAL_BOTTOM = 1939,
    AF_BLUE_STRING_GREEK_SMALL_BETA_TOP = 1957,
    AF_BLUE_STRING_GREEK_SMALL = 1975,
    AF_BLUE_STRING_GREEK_SMALL_DESCENDER = 1999,
    AF_BLUE_STRING_GUJARATI_TOP = 2023,
    AF_BLUE_STRING_GUJARATI_BOTTOM = 2055,
    AF_BLUE_STRING_GUJARATI_ASCENDER = 2087,
    AF_BLUE_STRING_GUJARATI_DESCENDER = 2137,
    AF_BLUE_STRING_GUJARATI_DIGIT_TOP = 2170,
    AF_BLUE_STRING_GURMUKHI_BASE = 2190,
    AF_BLUE_STRING_GURMUKHI_HEAD = 2222,
    AF_BLUE_STRING_GURMUKHI_TOP = 2254,
    AF_BLUE_STRING_GURMUKHI_BOTTOM = 2286,
    AF_BLUE_STRING_GURMUKHI_DIGIT_TOP = 2318,
    AF_BLUE_STRING_HEBREW_TOP = 2338,
    AF_BLUE_STRING_HEBREW_BOTTOM = 2362,
    AF_BLUE_STRING_HEBREW_DESCENDER = 2380,
    AF_BLUE_STRING_KANNADA_TOP = 2395,
    AF_BLUE_STRING_KANNADA_BOTTOM = 2439,
    AF_BLUE_STRING_KHMER_TOP = 2471,
    AF_BLUE_STRING_KHMER_SUBSCRIPT_TOP = 2495,
    AF_BLUE_STRING_KHMER_BOTTOM = 2535,
    AF_BLUE_STRING_KHMER_DESCENDER = 2567,
    AF_BLUE_STRING_KHMER_LARGE_DESCENDER = 2601,
    AF_BLUE_STRING_KHMER_SYMBOLS_WAXING_TOP = 2688,
    AF_BLUE_STRING_KHMER_SYMBOLS_WANING_BOTTOM = 2696,
    AF_BLUE_STRING_LAO_TOP = 2704,
    AF_BLUE_STRING_LAO_BOTTOM = 2736,
    AF_BLUE_STRING_LAO_ASCENDER = 2768,
    AF_BLUE_STRING_LAO_LARGE_ASCENDER = 2784,
    AF_BLUE_STRING_LAO_DESCENDER = 2796,
    AF_BLUE_STRING_LATIN_CAPITAL_TOP = 2820,
    AF_BLUE_STRING_LATIN_CAPITAL_BOTTOM = 2836,
    AF_BLUE_STRING_LATIN_SMALL_F_TOP = 2852,
    AF_BLUE_STRING_LATIN_SMALL_TOP = 2866,
    AF_BLUE_STRING_LATIN_SMALL_BOTTOM = 2882,
    AF_BLUE_STRING_LATIN_SMALL_DESCENDER = 2898,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_TOP = 2908,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_BOTTOM = 2928,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_F_TOP = 2948,
    AF_BLUE_STRING_LATIN_SUBS_SMALL = 2968,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_DESCENDER = 3004,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_TOP = 3024,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_BOTTOM = 3055,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_F_TOP = 3084,
    AF_BLUE_STRING_LATIN_SUPS_SMALL = 3110,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_DESCENDER = 3135,
    AF_BLUE_STRING_LISU_TOP = 3146,
    AF_BLUE_STRING_LISU_BOTTOM = 3178,
    AF_BLUE_STRING_MALAYALAM_TOP = 3210,
    AF_BLUE_STRING_MALAYALAM_BOTTOM = 3254,
    AF_BLUE_STRING_MYANMAR_TOP = 3286,
    AF_BLUE_STRING_MYANMAR_BOTTOM = 3318,
    AF_BLUE_STRING_MYANMAR_ASCENDER = 3350,
    AF_BLUE_STRING_MYANMAR_DESCENDER = 3378,
    AF_BLUE_STRING_NKO_TOP = 3410,
    AF_BLUE_STRING_NKO_BOTTOM = 3434,
    AF_BLUE_STRING_NKO_SMALL_TOP = 3449,
    AF_BLUE_STRING_NKO_SMALL_BOTTOM = 3458,
    AF_BLUE_STRING_OL_CHIKI = 3470,
    AF_BLUE_STRING_OLD_TURKIC_TOP = 3494,
    AF_BLUE_STRING_OLD_TURKIC_BOTTOM = 3509,
    AF_BLUE_STRING_OSAGE_CAPITAL_TOP = 3529,
    AF_BLUE_STRING_OSAGE_CAPITAL_BOTTOM = 3569,
    AF_BLUE_STRING_OSAGE_CAPITAL_DESCENDER = 3599,
    AF_BLUE_STRING_OSAGE_SMALL_TOP = 3614,
    AF_BLUE_STRING_OSAGE_SMALL_BOTTOM = 3654,
    AF_BLUE_STRING_OSAGE_SMALL_ASCENDER = 3694,
    AF_BLUE_STRING_OSAGE_SMALL_DESCENDER = 3719,
    AF_BLUE_STRING_OSMANYA_TOP = 3734,
    AF_BLUE_STRING_OSMANYA_BOTTOM = 3774,
    AF_BLUE_STRING_SAURASHTRA_TOP = 3814,
    AF_BLUE_STRING_SAURASHTRA_BOTTOM = 3846,
    AF_BLUE_STRING_SHAVIAN_TOP = 3866,
    AF_BLUE_STRING_SHAVIAN_BOTTOM = 3876,
    AF_BLUE_STRING_SHAVIAN_DESCENDER = 3901,
    AF_BLUE_STRING_SHAVIAN_SMALL_TOP = 3911,
    AF_BLUE_STRING_SHAVIAN_SMALL_BOTTOM = 3946,
    AF_BLUE_STRING_SINHALA_TOP = 3961,
    AF_BLUE_STRING_SINHALA_BOTTOM = 3993,
    AF_BLUE_STRING_SINHALA_DESCENDER = 4025,
    AF_BLUE_STRING_SUNDANESE_TOP = 4069,
    AF_BLUE_STRING_SUNDANESE_BOTTOM = 4093,
    AF_BLUE_STRING_SUNDANESE_DESCENDER = 4125,
    AF_BLUE_STRING_TAI_VIET_TOP = 4133,
    AF_BLUE_STRING_TAI_VIET_BOTTOM = 4153,
    AF_BLUE_STRING_TAMIL_TOP = 4165,
    AF_BLUE_STRING_TAMIL_BOTTOM = 4197,
    AF_BLUE_STRING_TELUGU_TOP = 4229,
    AF_BLUE_STRING_TELUGU_BOTTOM = 4257,
    AF_BLUE_STRING_THAI_TOP = 4285,
    AF_BLUE_STRING_THAI_BOTTOM = 4309,
    AF_BLUE_STRING_THAI_ASCENDER = 4337,
    AF_BLUE_STRING_THAI_LARGE_ASCENDER = 4349,
    AF_BLUE_STRING_THAI_DESCENDER = 4361,
    AF_BLUE_STRING_THAI_LARGE_DESCENDER = 4377,
    AF_BLUE_STRING_THAI_DIGIT_TOP = 4385,
    AF_BLUE_STRING_TIFINAGH = 4397,
    AF_BLUE_STRING_VAI_TOP = 4429,
    AF_BLUE_STRING_VAI_BOTTOM = 4461,
    af_blue_1_1 = 4492,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRING_CJK_TOP = af_blue_1_1 + 1,
    AF_BLUE_STRING_CJK_BOTTOM = af_blue_1_1 + 203,
    af_blue_1_1_1 = af_blue_1_1 + 404,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    AF_BLUE_STRING_CJK_LEFT = af_blue_1_1_1 + 1,
    AF_BLUE_STRING_CJK_RIGHT = af_blue_1_1_1 + 204,
    af_blue_1_1_2 = af_blue_1_1_1 + 405,
#else
    af_blue_1_1_2 = af_blue_1_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_1_2 = af_blue_1_1_2 + 0,
#else
    af_blue_1_2 = af_blue_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRING_MAX   /* do not remove */

  } AF_Blue_String;


  FT_LOCAL_ARRAY( char )
  af_blue_strings[];


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                 B L U E   S T R I N G S E T S                 *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* The next level is to group blue strings into style-specific sets. */


  /* Properties are specific to a writing system.  We assume that a given  */
  /* blue string can't be used in more than a single writing system, which */
  /* is a safe bet.                                                        */
#define AF_BLUE_PROPERTY_LATIN_TOP       ( 1U << 0 )  /* must have value 1 */
#define AF_BLUE_PROPERTY_LATIN_SUB_TOP   ( 1U << 1 )
#define AF_BLUE_PROPERTY_LATIN_NEUTRAL   ( 1U << 2 )
#define AF_BLUE_PROPERTY_LATIN_X_HEIGHT  ( 1U << 3 )
#define AF_BLUE_PROPERTY_LATIN_LONG      ( 1U << 4 )

#define AF_BLUE_PROPERTY_CJK_TOP    ( 1U << 0 )       /* must have value 1 */
#define AF_BLUE_PROPERTY_CJK_HORIZ  ( 1U << 1 )       /* must have value 2 */
#define AF_BLUE_PROPERTY_CJK_RIGHT  AF_BLUE_PROPERTY_CJK_TOP


#define AF_BLUE_STRINGSET_MAX_LEN  8

  /* The AF_Blue_Stringset enumeration values are offsets into the */
  /* `af_blue_stringsets' array.                                   */

  typedef enum  AF_Blue_Stringset_
  {
    AF_BLUE_STRINGSET_ADLM = 0,
    AF_BLUE_STRINGSET_ARAB = 5,
    AF_BLUE_STRINGSET_ARMN = 9,
    AF_BLUE_STRINGSET_AVST = 16,
    AF_BLUE_STRINGSET_BENG = 19,
    AF_BLUE_STRINGSET_BUHD = 24,
    AF_BLUE_STRINGSET_CANADIAN_SYLLABICS = 29,
    AF_BLUE_STRINGSET_CARI = 36,
    AF_BLUE_STRINGSET_CHER = 39,
    AF_BLUE_STRINGSET_COPT = 46,
    AF_BLUE_STRINGSET_CPRT = 51,
    AF_BLUE_STRINGSET_CYRL = 56,
    AF_BLUE_STRINGSET_DEVA = 62,
    AF_BLUE_STRINGSET_DSRT = 68,
    AF_BLUE_STRINGSET_ETHI = 73,
    AF_BLUE_STRINGSET_GEOR = 76,
    AF_BLUE_STRINGSET_GEOK = 81,
    AF_BLUE_STRINGSET_GLAG = 88,
    AF_BLUE_STRINGSET_GOTH = 93,
    AF_BLUE_STRINGSET_GREK = 96,
    AF_BLUE_STRINGSET_GUJR = 103,
    AF_BLUE_STRINGSET_GURU = 109,
    AF_BLUE_STRINGSET_HEBR = 115,
    AF_BLUE_STRINGSET_KNDA = 119,
    AF_BLUE_STRINGSET_KHMR = 122,
    AF_BLUE_STRINGSET_KHMS = 128,
    AF_BLUE_STRINGSET_LAO = 131,
    AF_BLUE_STRINGSET_LATN = 137,
    AF_BLUE_STRINGSET_LATB = 144,
    AF_BLUE_STRINGSET_LATP = 151,
    AF_BLUE_STRINGSET_LISU = 158,
    AF_BLUE_STRINGSET_MLYM = 161,
    AF_BLUE_STRINGSET_MYMR = 164,
    AF_BLUE_STRINGSET_NKOO = 169,
    AF_BLUE_STRINGSET_NONE = 174,
    AF_BLUE_STRINGSET_OLCK = 175,
    AF_BLUE_STRINGSET_ORKH = 178,
    AF_BLUE_STRINGSET_OSGE = 181,
    AF_BLUE_STRINGSET_OSMA = 189,
    AF_BLUE_STRINGSET_SAUR = 192,
    AF_BLUE_STRINGSET_SHAW = 195,
    AF_BLUE_STRINGSET_SINH = 201,
    AF_BLUE_STRINGSET_SUND = 205,
    AF_BLUE_STRINGSET_TAML = 209,
    AF_BLUE_STRINGSET_TAVT = 212,
    AF_BLUE_STRINGSET_TELU = 215,
    AF_BLUE_STRINGSET_THAI = 218,
    AF_BLUE_STRINGSET_TFNG = 226,
    AF_BLUE_STRINGSET_VAII = 229,
    af_blue_2_1 = 232,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRINGSET_HANI = af_blue_2_1 + 0,
    af_blue_2_1_1 = af_blue_2_1 + 2,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    af_blue_2_1_2 = af_blue_2_1_1 + 2,
#else
    af_blue_2_1_2 = af_blue_2_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_2_2 = af_blue_2_1_2 + 1,
#else
    af_blue_2_2 = af_blue_2_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRINGSET_MAX   /* do not remove */

  } AF_Blue_Stringset;


  typedef struct  AF_Blue_StringRec_
  {
    AF_Blue_String  string;
    FT_UShort       properties;

  } AF_Blue_StringRec;


  FT_LOCAL_ARRAY( AF_Blue_StringRec )
  af_blue_stringsets[];

/* */

FT_END_HEADER


#endif /* AFBLUE_H_ */


/* END */
